//slowmem.cpp by Theo Schouten
// compiled with Codeblocks, MINGW compiler on Windows XP

/*
//less acurate timer
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

static clock_t ttstart, ttfinish, ttdiff;
#define TS ttstart = clock()
#define TF ttfinish = clock()
#define TP(s) printf("%s: %lf sec\n",s,(double) (ttfinish-ttstart) / CLK_TCK)
*/

// more accurate timer, needs .cpp extention on file name
#include <cstdio>
#include <cstdlib>
#include <cstdarg>
#include <cstring>
#include <cmath>
#include <ctime>
#include <windows.h>

static _LARGE_INTEGER dstart, dfinish, dfreq;
#define TS QueryPerformanceFrequency(&dfreq); QueryPerformanceCounter(&dstart)
#define TF QueryPerformanceCounter(&dfinish)
#define TP(s) printf("%s: %lf sec\n",s,((double)(dfinish.QuadPart - dstart.QuadPart))/((double)dfreq.QuadPart))

// size of the image
#define SIZE 8192

float img[SIZE][SIZE]; // input image
float res[SIZE][SIZE]; //result of mean filter

main(int argc, char *argv[])
{
    int i,j,k,l;
    for(i=0;i<SIZE;i++) for(j=0;j<SIZE;j++) img[j][i] = (2*j+i)%8196;
    printf("\nSize of image: %d\n",SIZE);
TS;
    for(i=1;i<SIZE-1;i++) for(j=1;j<SIZE-1;j++) {
        res[j][i]=0;
        for(k=-1;k<2;k++) for(l=-1;l<2;l++) res[j][i] += img[j+l][i+k];
        res[j][i] /= 9;
    }
TF;
TP("Time: ");
system("pause");
   return 0;
}
